﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class RadGrid_Filtering_FilterIssue : System.Web.UI.Page
{
    //AppPermission objApp = new AppPermission();
    //Users objusers = new Users();
    //string strFilters = "";

    public DataTable BindApplications()
    {
        //the table index (.Tables[1]) in the below statement is done 
        //for TEMPORARY SUPPORT of old UPM and must changed back to (.Tables[0]) 
        //after this new UPM is rolled OUT
        /********************************************************************************************************************************************/
        //DataView aView = objApp.ListApplications().Tables[1].DefaultView;
        /********************************************************************************************************************************************/

        //aView.RowFilter = "Active=" + ((chkshowinactive.Checked) ? false : true).ToString();
        DataTable table = new DataTable();

        table.Columns.Add("AppName");
        table.Columns.Add("NoOfPermTypes", typeof(int));
        table.Columns.Add("AppID", typeof(int));
        table.Columns.Add("Active");
        table.Columns.Add("WebBased");
        table.Columns.Add("ModifiedOn", typeof(DateTime));
        table.Columns.Add("ModifiedBy");

        for (int i = 1; i < 20; i++)
        {
            table.Rows.Add("AppName" + i, i, i, true, "WebBased" + i, new DateTime(2014, 12, i), "ModifiedBy" + i);
        }

        return table;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        //((HtmlGenericControl)this.Master.FindControl("liApps")).Attributes.Add("class", "SelectedMainMenu");

        if (!IsPostBack)
        {
            if (Session["PERMISSIONLOGONUSER"] == null)
                Page.ClientScript.RegisterStartupScript(this.GetType(), "CallMyFunction", "document.getElementById('CTP_hdUserName').value = document.getElementById('lblSupplier').innerText;", true);
        }
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        //RadGrid1.DataSource = ApplicationsTable;
        //RadGrid1.DataBind();
        //ApplicationsTable.PrimaryKey = new DataColumn[] { ApplicationsTable.Columns["AppID"] };

        RadGrid1.MasterTableView.EditMode = (GridEditMode)Enum.Parse(typeof(GridEditMode), "PopUp");
        //GridFilterMenu menu = RadGrid1.FilterMenu;
        //int i = 0;
        //while (i < menu.Items.Count)
        //{
        //    if (menu.Items[i].Text == "NoFilter" ||
        //        menu.Items[i].Text == "Contains" ||
        //        menu.Items[i].Text == "DoesNotContain" ||
        //        menu.Items[i].Text == "StartsWith" ||
        //        menu.Items[i].Text == "EndsWith" ||
        //        menu.Items[i].Text == "EqualTo" ||
        //        menu.Items[i].Text == "NotEqualTo"
        //        )
        //        i++;
        //    else
        //        menu.Items.RemoveAt(i);
        //}
    }

    protected void rad_needpermssion_SelectedIndexChanged(object sender, EventArgs e)
    {
        Session["Applications"] = null;
        RadGrid1.MasterTableView.Rebind();
    }

    protected void RadGrid1_PreRender(object sender, System.EventArgs e)
    {
        if (!IsPostBack && RadGrid1.MasterTableView.Items.Count > 1)
        {
            //RadGrid1.MasterTableView.Items[1].Edit = true;
            //RadGrid1.EditIndexes.Add(0);
            //RadGrid1.MasterTableView.Rebind();
            //RadGrid1.Rebind();
        }
    }

    private DataTable ApplicationsTable
    {
        get
        {
            object obj = Session["Applications"];
            DataTable myDataTable = new DataTable();
            if (obj != null)
            {
                myDataTable = (DataTable)obj;

                //bool bActive = true;
                //bActive = (chkshowinactive.Checked) ? false : true;
                //myDataTable.DefaultView.RowFilter = "Active='" + bActive.ToString() + "'";
                //myDataTable = myDataTable.DefaultView.ToTable();
                //return myDataTable;
            }
            else
                myDataTable = BindApplications();

            //DataView aView = myDataTable.DefaultView;
            //aView.RowFilter = strFilters;

            //myDataTable = aView.ToTable();

            //DataTable datasource;
            //if (strFilters != "")
            //{
            //DataRow[] drArr = myDataTable.Select(strFilters);
            //DataTable dtFiltered = myDataTable.Clone();

            //foreach (DataRow dr in drArr)
                //dtFiltered.ImportRow(dr);

            //    datasource = ApplicationsTable;
            //    DataView aView = datasource.DefaultView;
            //    aView.RowFilter = strFilters;

            //    datasource = aView.ToTable();
            //}
            //else
            //    datasource = ApplicationsTable;
            //DataView aView = ApplicationsTable.DefaultView;
            //aView.RowFilter = strFilters;
            //DataTable dtFiltered = aView.ToTable();

            Session["Applications"] = myDataTable;
            return myDataTable;
        }
    }

    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        RadGrid1.DataSource = ApplicationsTable;
        ApplicationsTable.PrimaryKey = new DataColumn[] { ApplicationsTable.Columns["AppID"] };
    }

    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridDataItem)
        {
            //Get the instance of the right type
            GridDataItem dataBoundItem = e.Item as GridDataItem;

            //Check the formatting condition
            if (dataBoundItem["Active"].Text.ToLower() == "true")
            {
                dataBoundItem["Active"].Text = "YES";
                dataBoundItem["Active"].ForeColor = Color.Green;
                dataBoundItem["Active"].Font.Bold = true;
                dataBoundItem["AppName"].ForeColor = Color.Green;
                dataBoundItem["AppName"].Font.Bold = true;
            }
            else
            {
                dataBoundItem["Active"].Text = "NO";
                dataBoundItem["Active"].ForeColor = Color.Red;
                dataBoundItem["AppName"].ForeColor = Color.Red;
            }
            if (dataBoundItem["WebBased"].Text.ToLower() == "true")
            {
                dataBoundItem["WebBased"].Text = "YES";
                dataBoundItem["WebBased"].ForeColor = Color.Green;
                dataBoundItem["WebBased"].Font.Bold = true;
            }
            else
            {
                dataBoundItem["WebBased"].Text = "NO";
                dataBoundItem["WebBased"].ForeColor = Color.Red;
            }
        }
        if ((e.Item is GridEditableItem) && (e.Item.IsInEditMode))
        {
            GridEditableItem editform = (GridEditableItem)e.Item;
            TextBox txtAppName = (TextBox)editform.FindControl("txtAppName");
            Button btnUpdate = (Button)editform.FindControl("btnUpdate");
            Label lblError1 = (Label)editform.FindControl("lblError1");
            //btnUpdate.Attributes.Add("onclick", "return clientValidation(" + txtAppName.ClientID + "," + lblError1.ClientID + ");");
            btnUpdate.Attributes.Add("onclick", "if(document.getElementById('" + txtAppName.ClientID + "').value == '') { document.getElementById('" +
                lblError1.ClientID + "').innerText = 'Application name cannot be empty.'; document.getElementById('" + txtAppName.ClientID + "').focus(); return false; }");
            txtAppName.Attributes.Add("onkeydown", "document.getElementById('" + lblError1.ClientID + "').innerText = '';");
        }
    }

    //protected void RadGrid1_UpdateCommand(object source, GridCommandEventArgs e)
    //{
    //    GridEditableItem editedItem = e.Item as GridEditableItem;
    //    TextBox txtAppName = (TextBox)editedItem.FindControl("txtAppName");
    //    CheckBox chkWebBased = (CheckBox)editedItem.FindControl("chkWebBased");
    //    CheckBox chkActive = (CheckBox)editedItem.FindControl("chkActive");
    //    Label lblError1 = (Label)editedItem.FindControl("lblError1");

    //    //Prepare new row to add it in the DataSource
    //    string sAppID = editedItem.OwnerTableView.DataKeyValues[editedItem.ItemIndex]["AppID"].ToString();
    //    DataRow[] changedRows = ApplicationsTable.Select("AppID = " + sAppID);

    //    Label lblError = new Label();
    //    RadGrid1.Controls.Add(lblError);

    //    if (changedRows.Length != 1)
    //    {
    //        lblError1.Text = "Unable to locate the Application for updating.";
    //        e.Canceled = true;
    //        return;
    //    }
    //    if (txtAppName.Text == "")
    //    {
    //        lblError1.Text = "Application name cannot be empty.";
    //        txtAppName.Focus();
    //        e.Canceled = true;
    //        return;
    //    }

    //    //Update new values
    //    Hashtable newValues = new Hashtable();
    //    newValues["AppName"] = txtAppName.Text;
    //    newValues["WebBased"] = chkWebBased.Checked;
    //    newValues["Active"] = chkActive.Checked;
    //    newValues["ModifiedOn"] = DateTime.Now;
    //    newValues["ModifiedBy"] = "";

    //    changedRows[0].BeginEdit();
    //    try
    //    {
    //        foreach (DictionaryEntry entry in newValues)
    //            changedRows[0][(string)entry.Key] = entry.Value;

    //        changedRows[0].EndEdit();
    //        ApplicationsTable.AcceptChanges();

    //        objApp.APPID = Convert.ToInt32(sAppID);
    //        objApp.AppName = txtAppName.Text;
    //        objApp.WebBased = (chkWebBased.Checked) ? 1 : 0;
    //        objApp.AppStatus = (chkActive.Checked) ? 1 : 0;
    //        objApp.CurrentUser = "";

    //        int ischanged = objApp.ChangeAppStatus();

    //        lblError.Text = "Application is updated successfully!";
    //        lblError.ForeColor = Color.Green;
    //    }
    //    catch (Exception ex)
    //    {
    //        changedRows[0].CancelEdit();
    //        lblError1.Text = "Unable to update Application. Reason: " + ex.Message;
    //        e.Canceled = true;
    //    }
    //}

    //protected void RadGrid1_InsertCommand(object source, GridCommandEventArgs e)
    //{
    //    GridEditableItem editedItem = e.Item as GridEditableItem;
    //    TextBox txtAppName = (TextBox)editedItem.FindControl("txtAppName");
    //    CheckBox chkWebBased = (CheckBox)editedItem.FindControl("chkWebBased");
    //    CheckBox chkActive = (CheckBox)editedItem.FindControl("chkActive");
    //    Label lblError1 = (Label)editedItem.FindControl("lblError1");

    //    //Create new row in the DataSource
    //    DataRow newRow = ApplicationsTable.NewRow();

    //    Label lblError = new Label();
    //    RadGrid1.Controls.Add(lblError);

    //    if (txtAppName.Text == "")
    //    {
    //        lblError1.Text = "Application name cannot be empty.";
    //        txtAppName.Focus();
    //        e.Canceled = true;
    //        return;
    //    }

    //    //Insert new values
    //    Hashtable newValues = new Hashtable();
    //    newValues["AppName"] = txtAppName.Text;
    //    newValues["WebBased"] = chkWebBased.Checked;
    //    newValues["Active"] = chkActive.Checked;
    //    newValues["ModifiedOn"] = DateTime.Now;
    //    newValues["ModifiedBy"] = "";

    //    //make sure that unique primary key value is generated for the inserted row
    //    try
    //    {
    //        objApp.APPID = 0;
    //        objApp.AppName = txtAppName.Text;
    //        objApp.WebBased = (chkWebBased.Checked) ? 1 : 0;
    //        objApp.AppStatus = (chkActive.Checked) ? 1 : 0;
    //        objApp.CurrentUser = "";

    //        newValues["AppID"] = objApp.ChangeAppStatus();

    //        foreach (DictionaryEntry entry in newValues)
    //            newRow[(string)entry.Key] = entry.Value;
    //        ApplicationsTable.Rows.Add(newRow);
    //        ApplicationsTable.AcceptChanges();

    //        lblError.Text = "<font color=Green>Application is inserted successfully!</font>";
    //        lblError.ForeColor = Color.Green;
    //    }
    //    catch (Exception ex)
    //    {
    //        lblError1.Text = "Unable to insert Application. Reason: " + ex.Message;
    //        e.Canceled = true;
    //    }
    //}

    protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    {
        //if (e.CommandName == RadGrid.FilterCommandName)
        //{
        //    Pair filterPair = (Pair)e.CommandArgument;
        //    string s1 = "Current Filter function: '" + filterPair.First + "' for column '" + filterPair.Second + "'";
        //    TextBox filterBox = (e.Item as GridFilteringItem)[filterPair.Second.ToString()].Controls[0] as TextBox;
        //    string s2 = "<br> Entered pattern for search: " + filterBox.Text;


        //    if (strFilters != "")
        //    {
        //        switch (filterPair.First.ToString())
        //        {
        //            case "Contains":
        //                strFilters = strFilters + " and " + filterPair.Second + " like '%" + filterBox.Text + "%'";
        //                break;
        //            case "DoesNotContain":
        //                strFilters = strFilters + " and " + filterPair.Second + " not like '%" + filterBox.Text + "%'";
        //                break;
        //            case "StartsWith":
        //                strFilters = strFilters + " and " + filterPair.Second + " like '%>" + filterBox.Text + "%'";
        //                break;
        //            case "EndsWith":
        //                strFilters = strFilters + " and " + filterPair.Second + " like '%" + filterBox.Text + "</%'";
        //                break;
        //            case "EqualTo":
        //                strFilters = strFilters + " and " + filterPair.Second + " like '%>" + filterBox.Text + "</%'";
        //                break;
        //            case "NotEqualTo":
        //                strFilters = strFilters + " and " + filterPair.Second + " not like '%>" + filterBox.Text + "</%'";
        //                break;
        //        }
        //        //strFilters = strFilters + " and " + filterExpressions[i].FieldName + " like '%" + filterExpressions[i].FieldValue + "%'";
        //    }
        //    else
        //    {
        //        switch (filterPair.First.ToString())
        //        {
        //            case "Contains":
        //                strFilters = filterPair.Second + " like '%" + filterBox.Text + "%'";
        //                break;
        //            case "DoesNotContain":
        //                strFilters = filterPair.Second + " not like '%" + filterBox.Text + "%'";
        //                break;
        //            case "StartsWith":
        //                strFilters = filterPair.Second + " like '%>" + filterBox.Text + "%'";
        //                break;
        //            case "EndsWith":
        //                strFilters = filterPair.Second + " like '%" + filterBox.Text + "</%'";
        //                break;
        //            case "EqualTo":
        //                strFilters = filterPair.Second + " like '%>" + filterBox.Text + "</%'";
        //                break;
        //            case "NotEqualTo":
        //                strFilters = filterPair.Second + " not like '%>" + filterBox.Text + "</%'";
        //                break;
        //        }
        //        //strFilters = filterExpressions[i].FieldName + " like '%" + filterExpressions[i].FieldValue + "%'";
        //    }
        //    //RadGrid1.MasterTableView.FilterExpression = strFilters;
        //    //RadGrid1.MasterTableView.Rebind();
        //    //ApplicationsTable.DefaultView.RowFilter = strFilters;
        //    //RadGrid1.DataSource = ApplicationsTable.DefaultView.ToTable();
        //    Session["Applications"] = null;
        //    RadGrid1.MasterTableView.Rebind();
        //}
    }
}