﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="FilterIssue.aspx.cs" Inherits="RadGrid_Filtering_FilterIssue" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
        <telerik:RadScriptManager ID="RadScriptManager1" runat="server">
            <Scripts>
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.Core.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQuery.js" />
                <asp:ScriptReference Assembly="Telerik.Web.UI" Name="Telerik.Web.UI.Common.jQueryInclude.js" />
            </Scripts>
        </telerik:RadScriptManager>
        <script type="text/javascript">
            //Put your JavaScript code here.
        </script>
        <telerik:RadAjaxManager ID="RadAjaxManager1" runat="server">
        </telerik:RadAjaxManager>
        <asp:UpdatePanel ID="UpdatePanel2" runat="server">
            <ContentTemplate>

                <asp:CheckBox ID="chkshowinactive" runat="server" Visible="true"
                    Text="Show Inactive" CausesValidation="false"
                    Checked="false" OnCheckedChanged="rad_needpermssion_SelectedIndexChanged"
                    AutoPostBack="True" CssClass="Checkbox" />
                <br />

                <telerik:RadAjaxManagerProxy ID="RadAjaxManagerProxy1" runat="server">
                    <AjaxSettings>
                        <telerik:AjaxSetting>
                            <UpdatedControls>
                                <telerik:AjaxUpdatedControl ControlID="RadGrid1" LoadingPanelID="RadAjaxLoadingPanel1"></telerik:AjaxUpdatedControl>
                            </UpdatedControls>
                        </telerik:AjaxSetting>
                    </AjaxSettings>
                </telerik:RadAjaxManagerProxy>
                <telerik:RadGrid ID="RadGrid1" runat="server" AllowPaging="True" ShowFooter="True"
                    AllowSorting="True" AutoGenerateColumns="False" ShowStatusBar="True"
                    OnPreRender="RadGrid1_PreRender" OnNeedDataSource="RadGrid1_NeedDataSource"
                    OnItemDataBound="RadGrid1_ItemDataBound"
                    AllowFilteringByColumn="true" CellSpacing="-1" GridLines="Both">
                    <PagerStyle Mode="NextPrevAndNumeric" Position="TopAndBottom" />
                    <HeaderStyle Font-Bold="true" />
                    <MasterTableView CommandItemDisplay="Top" DataKeyNames="AppID" PageSize="15">
                        <EditFormSettings>
                            <PopUpSettings Modal="true" />
                        </EditFormSettings>
                        <Columns>
                            <telerik:GridEditCommandColumn UniqueName="EditCommandColumn" />
                            <telerik:GridBoundColumn Visible="true" SortExpression="AppName" DataField="AppName"
                                HeaderText="Application Name" ItemStyle-VerticalAlign="Top" />
                            <telerik:GridHyperLinkColumn DataTextField="NoOfPermTypes" SortExpression="NoOfPermTypes" HeaderText="# of Permission Types" DataNavigateUrlFields="AppID"
                                DataNavigateUrlFormatString="ApplicationPermission.aspx?AppID={0}" HeaderStyle-Font-Bold="true" HeaderStyle-HorizontalAlign="Left" />
                            <telerik:GridBoundColumn Visible="true" SortExpression="Active" DataField="Active"
                                HeaderText="Active" ItemStyle-VerticalAlign="Top" AllowFiltering="false" />
                            <telerik:GridBoundColumn Visible="true" SortExpression="WebBased" DataField="WebBased"
                                HeaderText="Web Based" ItemStyle-VerticalAlign="Top" AllowFiltering="false" />
                            <telerik:GridBoundColumn Visible="true" SortExpression="ModifiedOn" DataField="ModifiedOn"
                                HeaderText="Modified On" ItemStyle-VerticalAlign="Top" DataFormatString="{0:d-MMM-yyyy hh:mm tt}" />
                            <telerik:GridBoundColumn Visible="true" SortExpression="ModifiedBy" DataField="ModifiedBy"
                                HeaderText="Modified By" ItemStyle-VerticalAlign="Top" />
                        </Columns>
                    </MasterTableView>
                </telerik:RadGrid>
            </ContentTemplate>
        </asp:UpdatePanel>
    </form>
</body>
</html>
